<template>
  <!-- NAO VOU UTILIZAR -->
  <v-row justify="center">
    <v-dialog v-model="entitiesUpdate.open" persistent width="800px">
      <v-card>
        <v-toolbar dark color="primary">
          <v-toolbar-title>Editar entidade</v-toolbar-title>
        </v-toolbar>
        <v-card-text>
          <v-form ref="form" v-model="valid">
            <v-container>
              <v-row>
                <v-col cols="12" sm="12" md="12">
                  <v-text-field
                    v-model="entity.name"
                    label="Nome da entidade*"
                    required
                    prepend-icon="mdi-pencil-box-outline"
                  ></v-text-field>
                </v-col>
                <v-col cols="12" sm="12" md="12">
                  <v-select
                    v-model="entity.parentsId"
                    prepend-icon="mdi-book-multiple"
                    multiple
                    :items="entities"
                    item-text="name"
                    item-value="id"
                    label="Entidades pai"
                    dense
                  ></v-select>
                </v-col>
                <v-col cols="12" sm="12" md="12">
                  <v-select
                    prepend-icon="mdi-book-outline"
                    :items="entity.modules"
                    label="Módulos"
                    dense
                  ></v-select>
                </v-col>
                <v-col cols="12" sm="12" md="12">
                  <v-text-field
                    v-model="entity.firstName"
                    label="Nome principal"
                    required
                    prepend-icon="mdi-pencil"
                  ></v-text-field>
                </v-col>
                <v-col cols="12" sm="12" md="12">
                  <v-text-field
                    v-model="entity.initialDate"
                    label="Data de ínicio"
                    required
                    prepend-icon="mdi-calendar"
                  ></v-text-field>
                </v-col>
                <v-col cols="12" sm="12" md="12">
                  <v-text-field
                    v-model="entity.endDate"
                    v-mask="mask"
                    label="Data final"
                    required
                    prepend-icon="mdi-calendar-outline"
                  ></v-text-field>
                </v-col>
                <v-col cols="12" sm="12" md="12">
                  <v-row align="center">
                    <v-checkbox
                      v-model="entity.visible"
                      label="Entidade visível?"
                      class="ml-3"
                      required
                      prepend-icon="mdi-calendar-outline"
                    ></v-checkbox>
                  </v-row>
                </v-col>
              </v-row>
              <small>* campo obrigatório</small>
            </v-container>
          </v-form>
        </v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="lighter" text @click="handleClose">Fechar</v-btn>
          <v-btn color="lighter" text @click="handleUpdate">Salvar</v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </v-row>
</template>

<script>
import { mapMutations, mapState } from 'vuex'
import User from '../../services/user'
import Management from '../../services/management'
import { mask } from 'vue-the-mask'

export default {
  name: 'EntitiesUpdate',
  components: {},
  directives: {
    mask,
  },
  data: () => ({
    entity: {
      parentsId: [],
      name: '',
      modules: [],
      firstName: '',
      visible: false,
      initialDate: '',
      endDate: '',
    },
    entities: [],
    mask: '##/##/####',
    valid: false,
  }),
  computed: {
    ...mapState('user', ['entitiesUpdate', 'entityModules']),
  },
  watch: {
    entitiesUpdate(entityState) {
      console.log(entityState, "teste data")
      this.entity = entityState.entityUpdated
    },
  },
  async created() {
    const children = await this.$getItem('entityChildren')
    this.entities = children
    const routed = await this.$getItem('routedEntity')
    this.entities.push(routed)
  },
  methods: {
    ...mapMutations('user', ['UPDATE_ENTITIES_UPDATE']),
    handleClose() {
      this.$refs.form.reset()
      this.UPDATE_ENTITIES_UPDATE({
        open: false,
        entityUpdated: {},
      })
    },
    async handleUpdate(item) {
      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      const actionId = actionsMap.get('updateEntity').id
      console.log('clica em editaaaaaaaaaaaaar')
      try {
        console.log('VUEX update entity ->', this.entitiesUpdate)
        let ret = await Management.updateEntity(
          entityId,
          actionId,
          this.entitiesUpdate.id,
          this.entitiesUpdate
        )
        console.log('ret', ret)
      } catch (e) {
        console.log('e', e)
      }
      await this.$parent.readEntities()
      this.handleClose()
    },
  },
}
</script>

<style scoped></style>
